using System;

namespace Demo_4_Properties
{
	public class Person 
	{
		private string mName;
		private DateTime mDateOfBirth;

		public string Name 
		{
			get 
			{
				return mName;
			}

			set 
			{
				if ((value != null) && (value.Length > 0))
				{
					mName = value;
				}
				else 
				{
					throw new ApplicationException("Invalid name!");
				}
			}
		}

		public DateTime DateOfBirth
		{
			get
			{
				return mDateOfBirth;
			}

			set
			{
				if ((value.Year >= 1900) && (value.Year <= DateTime.Now.Year))
				{
					mDateOfBirth = value;
				}
				else 
				{
					throw new ApplicationException("Invalid date of birth!");
				}
			}
		}

		public int Age
		{
			get
			{
				DateTime now = DateTime.Now;
				int yearsOld = now.Year - mDateOfBirth.Year;

				DateTime birthdayThisYear = 
					new DateTime(now.Year, mDateOfBirth.Month,
					mDateOfBirth.Day, mDateOfBirth.Hour,
					mDateOfBirth.Minute, mDateOfBirth.Second);
				if (DateTime.Compare(now, birthdayThisYear) < 0) 
				{
					yearsOld--;
				}

				return yearsOld;
			}
		}
	}


	class PropertiesDemo
	{
		static void Main(string[] args)
		{
			Person person = new Person();
			person.Name = "Svetlin Nakov";
			person.DateOfBirth = new DateTime(1980, 6, 14);
			
			Console.WriteLine("{0} is born on {1:dd.MM.yyyy}.", 
				person.Name, person.DateOfBirth);

			Console.WriteLine("{0} is {1} years old.", 
				person.Name, person.Age);
		}
	}
}
